Skip to navigation

Sign up

View as Markdown

This call performs many actions. You can use this operation to implement the standard requirements for signing up a customer, such as validating the uniqueness of an account and limiting the number of subscriptions per account. Also, you can use this operation to create a subscription, generate an invoice, and collect payment for a new or existing customer.

Note: You need to have the Orders or Orders Harmonization feature enabled to use this API. For a new customer, you can perform the following tasks in one call. Note that you can skip creating a payment meethod and still get the subscription and invoice successfully created.

  • Create an account
  • Create a payment method
  • Subscribe to a product in the product catalog and create a subscription
  • Generate an invoice
  • Collect payment

For an existing customer, you can use an account identification field of an external system to specify the account. You can make make asynchronous requests when using the “Sign up” operation.

This call supports a subset of the functionality of our Create an order call. We generally recommend using “Create an order” instead of this call because the Orders call has the following advantages:

  • Provides options for managing the entire subscription lifecycle from creation through to cancellation using different order actions.
  • Allows the creation or modifying of multiple subscriptions in a single order.
  • Allows a single order to combine both recurring subscription digital goods or services with order line items for physical goods.
  • Orders are treated as atomic transactions. If any part fails, the entire order, subscription, and billing account creation are rolled back.

This call does have some unique abilities not supported by “Create an order”. You should consider using this call when you need to:

  • Use Account UPSERT functionality by specifying a custom external identifier.
  • Limit the number of subscriptions on an account

There are no deprecation plans for this call and we will continue to support this call.

Authentication

AuthorizationBearer

Use Bearer {{token}} in the Authorization header for authentication.

Headers

Idempotency-KeystringOptional<=255 characters
Specify a unique idempotency key if you want to perform an idempotent POST or PATCH request. Do not use this header in other request types. With this header specified, the Zuora server can identify subsequent retries of the same request using this value, which prevents the same operation from being performed multiple times by accident.
Accept-EncodingstringOptional

Include the Accept-Encoding: gzip header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response.

If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a Content-Encoding header with the compression algorithm so that your client can decompress it.

Content-EncodingstringOptional

Include the Content-Encoding: gzip header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.

Zuora-Track-IdstringOptional<=64 characters

A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue.

The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (:), semicolon (;), double quote ("), and quote (').

Zuora-Entity-IdsstringOptional

An entity ID. If you have Zuora Multi-entity enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.

Zuora-Org-IdsstringOptional

Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header.

The IDs must be a sub-set of the user’s accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user’s accessible orgs.

AcceptstringOptional

Expressed as MIME types that the client is able to understand. Using content negotiation, the server then selects one of the proposals, uses it and informs the client of its choice with the Content-Type response header. The possible response MIME types are application/json-seq compatible with http://jsonlines.org/, and text/csv compatible with RFC 4180. application/json-seq is the default response MIME type. If the Accept header is not sepecified, or set /, the response body is returned in application/json-seq MIME type.

Zuora-VersionstringOptional

The minor API version.

For a list of available minor versions, see API upgrades.

Request

This endpoint expects an object.
accountDataobjectOptional
The information of the account that you are to create through the "Sign up" operation.
accountIdentifierFieldstringOptional
Specify the name of the field that holds external account id
customFieldsmap from strings to anyOptional
Container for custom fields.
optionsobjectOptional
Invoice or Payment.
paymentDataobjectOptional
subscriptionDataobjectOptional

Response headers

Content-EncodingstringOptional

This header is returned if you specify the Accept-Encoding: gzip request header and the response contains over 1000 bytes of data.

Note that only the following MIME types support gzipped responses:

  • application/json
  • application/xml
  • text/html
  • text/csv
  • text/plain
RateLimit-LimitstringOptional

The request limit quota for the time window closest to exhaustion. See rate limits for more information.

RateLimit-Remainingdouble

The number of requests remaining in the time window closest to quota exhaustion. See rate limits for more information.

RateLimit-Resetdouble

The number of seconds until the quota resets for the time window closest to quota exhaustion. See rate limits for more information.

Zuora-Request-IdstringOptional
The Zuora internal identifier of the API call. You cannot control the value of this header.
Zuora-Track-IdstringOptional
A custom identifier for tracing the API call. If you specified a tracing identifier in the request headers, Zuora returns the same tracing identifier. Otherwise, Zuora does not set this header.
Concurrency-Limit-TypestringOptional

The type of the concurrency limit, which can be Default, High-volume transactions, or Object Query.

For more information, see Concurrent request limits.

Concurrency-Limit-Limitinteger

The total number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Concurrency-Limit-Remaininginteger

The remaining number of the permitted concurrent requests.

For more information, see Concurrent request limits.

Response

OK
accountIdstringOptional
The account id for the order.
accountNumberstringOptional
The account number for the order.
creditMemoIdstringOptional
An array of the credit memo id generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled.
creditMemoNumberstringOptional
An array of the credit memo numbers generated in this order request. The credit memo is only available if you have the Invoice Settlement feature enabled.
invoiceIdstringOptional
The invoice id generated in this order request
invoiceNumberstringOptional
The invoice number generated in this order request
orderNumberstringOptional
The order number of the order created.
paidAmountstringOptional
The total amount collected in this order request.
paymentIdstringOptional
The payment id that is collected in this order request.
paymentNumberstringOptional
The payment number that is collected in this order request.
processIdstringOptional
The Id of the process that handles the operation.
reasonslist of objectsOptional
statusenumOptional

Status of the order. Pending is only applicable for an order that contains a CreateSubscription order action.

Allowed values:
subscriptionIdstringOptional
The subscription id of the order.
subscriptionNumberstringOptional
The subscription number of the order.
successbooleanOptional
Indicates whether the call succeeded.

Errors

4XX
Client Request Error
500
Internal Server Error